-- $Id: //depot/Projects/StarWars/Run/Data/Scripts/AI/RebelAdvanceTechPlan.lua#14 $
--/////////////////////////////////////////////////////////////////////////////////////////////////
--
-- (C) Petroglyph Games, Inc.
--
--
--  *****           **                          *                   *
--  *   **          *                           *                   *
--  *    *          *                           *                   *
--  *    *          *     *                 *   *          *        *
--  *   *     *** ******  * **  ****      ***   * *      * *****    * ***
--  *  **    *  *   *     **   *   **   **  *   *  *    * **   **   **   *
--  ***     *****   *     *   *     *  *    *   *  *   **  *    *   *    *
--  *       *       *     *   *     *  *    *   *   *  *   *    *   *    *
--  *       *       *     *   *     *  *    *   *   * **   *   *    *    *
--  *       **       *    *   **   *   **   *   *    **    *  *     *   *
-- **        ****     **  *    ****     *****   *    **    ***      *   *
--                                          *        *     *
--                                          *        *     *
--                                          *       *      *
--                                      *  *        *      *
--                                      ****       *       *
--
--/////////////////////////////////////////////////////////////////////////////////////////////////
-- C O N F I D E N T I A L   S O U R C E   C O D E -- D O   N O T   D I S T R I B U T E
--/////////////////////////////////////////////////////////////////////////////////////////////////
--
--              $File: //depot/Projects/StarWars/Run/Data/Scripts/AI/RebelAdvanceTechPlan.lua $
--
--    Original Author: James Yarrow
--
--            $Author: James_Yarrow $
--
--            $Change: 29196 $
--
--          $DateTime: 2005/10/13 17:19:11 $
--
--          $Revision: #14 $
--
--/////////////////////////////////////////////////////////////////////////////////////////////////

require("pgevents")


function Definitions()
	DebugMessage("%s -- In Definitions", tostring(Script))
	
	Category = "Advance_Tech_Rebel"
	IgnoreTarget = true
	TaskForce = {
	{
		"TechForce",
		"DenyHeroAttach",
		"Droids_Team = 1"
	}
	}

	DebugMessage("%s -- Done Definitions", tostring(Script))
end

function TechForce_Thread()
	DebugMessage("%s -- In TechForce_Thread.", tostring(Script))
	
	TechForce.Set_As_Goal_System_Removable(false)
	
	Target = FindTarget(TechForce, "Is_Good_Slice_Target", "Enemy", 0.1)
	
	if not Target then
		DebugMessage("%s -- Unable to find target for TechForce!", tostring(Script))
		ScriptExit()
	end
	
	--AssembleForce(TechForce)
	--Goal is global so there's no staging area for AssembleForce, but since we're using a stealth unit we can stage at the target
	BlockOnCommand(TechForce.Produce_Force(Target))
		
	BlockOnCommand(TechForce.Move_To(Target))
		
	BlockOnCommand(LandUnits(TechForce))
	TechForce.Set_Plan_Result(true)	
	
	DebugMessage("%s -- TechForce done!", tostring(Script));
	ScriptExit()
end

function TechForce_Production_Failed(tf, failed_object_type)
	DebugMessage("%s -- Abandonning plan owing to production failure.", tostring(Script))
	ScriptExit()
end