-- $Id: //depot/Projects/StarWars/Run/Data/Scripts/AI/SpaceMode/SystematicDisable.lua#12 $
--/////////////////////////////////////////////////////////////////////////////////////////////////
--
-- (C) Petroglyph Games, Inc.
--
--
--  *****           **                          *                   *
--  *   **          *                           *                   *
--  *    *          *                           *                   *
--  *    *          *     *                 *   *          *        *
--  *   *     *** ******  * **  ****      ***   * *      * *****    * ***
--  *  **    *  *   *     **   *   **   **  *   *  *    * **   **   **   *
--  ***     *****   *     *   *     *  *    *   *  *   **  *    *   *    *
--  *       *       *     *   *     *  *    *   *   *  *   *    *   *    *
--  *       *       *     *   *     *  *    *   *   * **   *   *    *    *
--  *       **       *    *   **   *   **   *   *    **    *  *     *   *
-- **        ****     **  *    ****     *****   *    **    ***      *   *
--                                          *        *     *
--                                          *        *     *
--                                          *       *      *
--                                      *  *        *      *
--                                      ****       *       *
--
--/////////////////////////////////////////////////////////////////////////////////////////////////
-- C O N F I D E N T I A L   S O U R C E   C O D E -- D O   N O T   D I S T R I B U T E
--/////////////////////////////////////////////////////////////////////////////////////////////////
--
--              $File: //depot/Projects/StarWars/Run/Data/Scripts/AI/SpaceMode/SystematicDisable.lua $
--
--    Original Author: James Yarrow
--
--            $Author: Steve_Copeland $
--
--            $Change: 29670 $
--
--          $DateTime: 2005/10/19 15:31:29 $
--
--          $Revision: #12 $
--
--/////////////////////////////////////////////////////////////////////////////////////////////////

require("pgevents")




function Definitions()
	DebugMessage("%s -- In Definitions", tostring(Script))
	
	IgnoreTarget = true
	Category = "AlwaysOff"
	TaskForce = {
	{
		"MainForce"						
		,"Corvette | Frigate | Capital | Super = 2,6"
	},
	{
		"EscortForce"
--		,"EscortForce"
		,"Fighter = 1,4"
	}
	}
	
	AllowEngagedUnits = false
	
	DebugMessage("%s -- Done Definitions", tostring(Script))
end

function MainForce_Thread()
	BlockOnCommand(MainForce.Produce_Force())
	
	QuickReinforce(PlayerObject, AITarget, MainForce, EscortForce)

	Try_Ability(MainForce, "ROCKET_ATTACK")	
	BlockOnCommand(MainForce.Attack_Target(AITarget, "Shield_Generator", 500))
	BlockOnCommand(MainForce.Attack_Target(AITarget, "Engine", 500))
	MainForce.Activate_Ability("ROCKET_ATTACK", false)
				
	MainForce.Enable_Attack_Positioning(false)
	ScriptExit()
end

function EscortForce_Thread()
	BlockOnCommand(EscortForce.Produce_Force())

	QuickReinforce(PlayerObject, AITarget, EscortForce, MainForce)
	
	BlockOnCommand(EscortForce.Guard_Target(MainForce))
	
	while true do
		Escort(EscortForce, MainForce)
	end
end

function MainForce_No_Units_Remaining()
	DebugMessage("%s -- All units dead or non-buildable.  Abandonning plan.", tostring(Script))
	ScriptExit()
end

function MainForce_Target_Destroyed()
	DebugMessage("%s -- Target destroyed!  Exiting Script.", tostring(Script))
	ScriptExit()
end

function EscortForce_No_Units_Remaining()
	DebugMessage("%s -- Escort wiped out.  Bailing.", tostring(Script))
	ScriptExit()
end


